/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.equivalencia;

import com.rjconsultores.ventaboletos.entidad.ComisionistaExterno;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaEquivalencia;
import com.rjconsultores.ventaboletos.service.ComisionistaExternoService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderEmpresaEquivalencia;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaEmpresaEquivalenciaController")
@Scope("prototype")
public class BusquedaEmpresaEquivalenciaController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<EmpresaEquivalencia> plwEmpresaEquivalencia;
    @Autowired
    private ComisionistaExternoService comisionistaExternoService;
    @Autowired
    private EmpresaService empresaService;
    private MyListbox empresaEquivalenciaList;
    private Paging pagingEmpresaEquivalencia;
    private Combobox cmbEmpresa;
    private Combobox cmbComissionestaExterno;
    private Textbox txtEquivalencia;
    private List<ComisionistaExterno> lsComisionistaExterno;
    private List<Empresa> lsEmpresa;

    public Combobox getCmbComissionestaExterno() {
        return cmbComissionestaExterno;
    }

    public void setCmbComissionestaExterno(Combobox cmbComissionestaExterno) {
        this.cmbComissionestaExterno = cmbComissionestaExterno;
    }

    public MyListbox getEmpresaEquivalenciaList() {
        return empresaEquivalenciaList;
    }

    public void setEmpresaEquivalenciaList(MyListbox empresaEquivalenciaList) {
        this.empresaEquivalenciaList = empresaEquivalenciaList;
    }

    public List<ComisionistaExterno> getLsComisionistaExterno() {
        return lsComisionistaExterno;
    }

    public void setLsComisionistaExterno(List<ComisionistaExterno> lsComisionistaExterno) {
        this.lsComisionistaExterno = lsComisionistaExterno;
    }

    public Paging getPagingEmpresaEquivalencia() {
        return pagingEmpresaEquivalencia;
    }

    public void setPagingEmpresaEquivalencia(Paging pagingEmpresaEquivalencia) {
        this.pagingEmpresaEquivalencia = pagingEmpresaEquivalencia;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verEmpresaEquivalencia(new EmpresaEquivalencia());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsComisionistaExterno = comisionistaExternoService.obtenerTodos();
        lsEmpresa =  UsuarioLogado.getUsuarioLogado().getEmpresa();

        super.doAfterCompose(comp);

        empresaEquivalenciaList.setItemRenderer(new RenderEmpresaEquivalencia());
        empresaEquivalenciaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                EmpresaEquivalencia c = (EmpresaEquivalencia) empresaEquivalenciaList.getSelected();
                verEmpresaEquivalencia(c);
            }
        });

        cmbEmpresa.focus();
        refreshLista();
    }

    private void verEmpresaEquivalencia(EmpresaEquivalencia ee) {
        if (ee == null) {
            return;
        }

        Map args = new HashMap();
        args.put("empresaEquivalencia", ee);
        args.put("empresaEquivalenciaList", empresaEquivalenciaList);

        openWindow("/gui/equivalencia/editarEmpresaEquivalencia.zul",
                Labels.getLabel("editarEmpresaEquivalenciaController.window.title"),
                args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<EmpresaEquivalencia> parada =
                new HibernateSearchObject<EmpresaEquivalencia>(EmpresaEquivalencia.class, pagingEmpresaEquivalencia.getPageSize());

        if (cmbEmpresa.getSelectedItem() != null) {
            parada.addFilterEqual("empresa", (Empresa) cmbEmpresa.getSelectedItem().getValue());
        }else{
        	parada.addFilterIn("empresa", lsEmpresa);
		}

        Comboitem ce = cmbComissionestaExterno.getSelectedItem();
        if (ce != null) {
            ComisionistaExterno c = (ComisionistaExterno) ce.getValue();
            parada.addFilterEqual("comisionistaExterno", c);
        }
        if (!txtEquivalencia.getValue().equals("")) {
            parada.addFilterILike("equivalenciaId", txtEquivalencia.getValue());
        }
        parada.addFilterEqual("activo", Boolean.TRUE);

        parada.addSortAsc("empresa.nombempresa");

        plwEmpresaEquivalencia.init(parada, empresaEquivalenciaList, pagingEmpresaEquivalencia);

        if (empresaEquivalenciaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaEmpresaEquivalenciaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public List<Empresa> getLsEmpresa() {
        return lsEmpresa;
    }

    public void setLsEmpresa(List<Empresa> lsEmpresa) {
        this.lsEmpresa = lsEmpresa;
    }
}
